Index: XIOS/dev/dev_olga/src/server.cpp
===================================================================
--- XIOS/dev/dev_olga/src/server.cpp	(revision 992)
+++ XIOS/dev/dev_olga/src/server.cpp	(revision 1009)
@@ -22,6 +22,9 @@
     list<MPI_Comm> CServer::interComm ;
     std::list<MPI_Comm> CServer::contextInterComms;
+    int CServer::nbSndSrvPools = (CXios::serverLevel == 0) ? 0 : 1;
+    int CServer::poolNb = 0;
     bool CServer::isRoot = false ;
     int CServer::rank = INVALID_RANK;
+    int CServer::rankSndServers = 0;
     StdOFStream CServer::m_infoStream;
     StdOFStream CServer::m_errorStream;
@@ -43,4 +46,5 @@
       else is_MPI_Initialized=false ;
 
+
       // Not using OASIS
       if (!CXios::usingOasis)
@@ -52,6 +56,4 @@
         }
         CTimer::get("XIOS").resume() ;
-
-        int nbSrvLevels = 2;
 
         boost::hash<string> hashString ;
@@ -61,4 +63,5 @@
 
         unsigned long* hashAll ;
+        unsigned long* hashAllServers ;
 
 //        int rank ;
@@ -66,14 +69,17 @@
         int myColor ;
         int i,c ;
-        MPI_Comm newComm ;
+        MPI_Comm newComm, serversInterComm;
 
         MPI_Comm_size(CXios::globalComm, &size) ;
         MPI_Comm_rank(CXios::globalComm, &rank);
+
         hashAll=new unsigned long[size] ;
         MPI_Allgather(&hashServer, 1, MPI_LONG, hashAll, 1, MPI_LONG, CXios::globalComm) ;
 
-        map<unsigned long, int> colors ;
+        map<unsigned long, int> colors, colorsServers ;
         map<unsigned long, int> leaders ;
         map<unsigned long, int>::iterator it ;
+//        map<unsigned long, int> leadersServers ;
+        vector<int> leadersServers;
 
         for(i=0,c=0;i<size;i++)
@@ -87,6 +93,73 @@
         }
 
-        myColor=colors[hashServer] ;
-        MPI_Comm_split(MPI_COMM_WORLD, myColor, rank, &intraComm) ;
+        nbSndSrvPools = size - leaders[hashServer2];    // one proc per secondary-server pool
+
+        // Taking into account multiple pools on secondary server
+        if (nbSndSrvPools > 1)
+        {
+          if (CXios::serverLevel > 1)
+          {
+            int nbProcs = size - leaders[hashServer2];
+            int remain = nbProcs % nbSndSrvPools;
+            int procsPerPool = nbProcs / nbSndSrvPools;
+            rankSndServers = rank - leaders[hashServer2];
+            StdString strTmp = CXios::xiosCodeIdSnd;
+
+            if (remain == 0)
+            {
+              poolNb = rankSndServers/procsPerPool;
+            }
+            else
+            {
+              if (rankSndServers <= (procsPerPool + 1) * remain)
+                poolNb = rankSndServers/(procsPerPool+1);
+              else
+              {
+                poolNb = remain + 1;
+                rankSndServers -= (procsPerPool + 1) * remain;
+                rankSndServers -= procsPerPool;
+                poolNb += rankSndServers/procsPerPool;
+              }
+            }
+            strTmp += boost::lexical_cast<string>(poolNb+1);  // add 1 to avoid hashing zero
+            hashServer = hashString(strTmp);
+            hashServer2 = hashString(strTmp);
+          }
+        }
+
+        if (nbSndSrvPools > 1)
+        {
+          myColor = size;
+          MPI_Comm_split(MPI_COMM_WORLD, myColor, rank, &serversInterComm) ;
+        }
+        else
+        {
+          myColor=colors[hashServer] ;
+          MPI_Comm_split(MPI_COMM_WORLD, myColor, rank, &intraComm) ;
+        }
+
+        if (nbSndSrvPools > 1)
+        {
+          int sizeServers;
+//          int rankServers;
+//          MPI_Comm_rank(serversInterComm, &rankServers) ;
+          MPI_Comm_size(serversInterComm, &sizeServers) ;
+          hashAllServers=new unsigned long[sizeServers] ;
+          MPI_Allgather(&hashServer, 1, MPI_LONG, hashAllServers, 1, MPI_LONG, serversInterComm) ;
+
+          for(i=0, c=0; i<sizeServers; i++)
+          {
+            if (colorsServers.find(hashAllServers[i])==colorsServers.end())
+            {
+              colorsServers[hashAllServers[i]]=c ;
+//              leadersServers[hashAllServers[i]]= leaders[hashServer1] + i ;
+              leadersServers.push_back( leaders[hashServer1] + i );
+              c++ ;
+            }
+          }
+          myColor=colorsServers[hashServer] ;
+          MPI_Comm_split(serversInterComm, myColor, rank, &intraComm) ;
+        }
+
 
         if (CXios::serverLevel == 0)
@@ -104,5 +177,5 @@
                        <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< clientLeader<<endl ;
 
-               MPI_Intercomm_create(intraComm, 0, CXios::globalComm, clientLeader, 0, &newComm) ;
+              MPI_Intercomm_create(intraComm, 0, CXios::globalComm, clientLeader, 0, &newComm) ;
                interCommLeft.push_back(newComm) ;
                interComm.push_back(newComm) ;
@@ -110,61 +183,114 @@
           }
         }
-
-        else if ((CXios::serverLevel == 1))
-        {
-          int clientLeader;
-          int srvSndLeader;
-          for(it=leaders.begin();it!=leaders.end();it++)
+        else
+        {
+          if ((CXios::serverLevel == 1))
           {
-            if (it->first != hashServer2)
-            {
-              if (it->first != hashServer1)
+            // Creating interComm with client (interCommLeft)
+            int clientLeader;
+            int srvSndLeader;
+            for(it=leaders.begin();it!=leaders.end();it++)
+            {
+              if (it->first != hashServer2)
               {
-                clientLeader=it->second ;
-                int intraCommSize, intraCommRank ;
-                MPI_Comm_size(intraComm,&intraCommSize) ;
-                MPI_Comm_rank(intraComm,&intraCommRank) ;
-                info(50)<<"intercommCreate::server "<<rank<<" intraCommSize : "<<intraCommSize
-                         <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< clientLeader<<endl ;
-                MPI_Intercomm_create(intraComm, 0, CXios::globalComm, clientLeader, 0, &newComm) ;
-                interCommLeft.push_back(newComm) ;
-                interComm.push_back(newComm) ;
+                if (it->first != hashServer1)
+                {
+                  clientLeader=it->second ;
+                  int intraCommSize, intraCommRank ;
+                  MPI_Comm_size(intraComm, &intraCommSize) ;
+                  MPI_Comm_rank(intraComm, &intraCommRank) ;
+                  info(50)<<"intercommCreate::server "<<rank<<" intraCommSize : "<<intraCommSize
+                           <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< clientLeader<<endl ;
+                  MPI_Intercomm_create(intraComm, 0, CXios::globalComm, clientLeader, 0, &newComm) ;
+                  interCommLeft.push_back(newComm) ;
+                  interComm.push_back(newComm) ;
+                }
               }
+              else
+              {
+                srvSndLeader = it->second;
+              }
+            }
+
+            // Creating interComm with secondary server pool(s) (interCommRight)
+//            if (nbSndSrvPools < 1)
+            if (nbSndSrvPools < 2)
+            {
+              CClient::initializeClientOnServer(rank, intraComm, srvSndLeader);
+              interCommRight.push_back(CClient::getInterComm());
+              interComm.push_back(CClient::getInterComm());
             }
             else
             {
-              srvSndLeader = it->second;
-            }
-          }
-
-          CClient::initializeClientOnServer(rank, intraComm, srvSndLeader);
-          interCommRight.push_back(CClient::getInterComm());
-          interComm.push_back(CClient::getInterComm());
-
-        }
-
-        else // secondary server pool
-        {
-          int clientLeader;
-          for(it=leaders.begin();it!=leaders.end();it++)
+//              for(it=leadersServers.begin();it!=leadersServers.end();it++)
+//              {
+//                if (it->first != hashServer)
+//                {
+//                  srvSndLeader = it->second;
+//                  CClient::initializeClientOnServer(rank, intraComm, srvSndLeader);
+//                  interCommRight.push_back(CClient::getInterComm());
+//                  interComm.push_back(CClient::getInterComm());
+//                }
+//              }
+
+              for(int i = 1; i < leadersServers.size(); ++i)
+              {
+                srvSndLeader = leadersServers[i];
+                CClient::initializeClientOnServer(rank, intraComm, srvSndLeader);
+                interCommRight.push_back(CClient::getInterComm());
+                interComm.push_back(CClient::getInterComm());
+              }
+            }
+          } // primary server
+
+          else // secondary server pool(s)
           {
-            if (it->first == hashServer1)
-            {
-              clientLeader=it->second ;
-              int intraCommSize, intraCommRank ;
-              MPI_Comm_size(intraComm,&intraCommSize) ;
-              MPI_Comm_rank(intraComm,&intraCommRank) ;
-              info(50)<<"intercommCreate::server "<<rank<<" intraCommSize : "<<intraCommSize
-                       <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< clientLeader<<endl ;
-
-              MPI_Intercomm_create(intraComm, 0, CXios::globalComm, clientLeader, 0, &newComm) ;
-              interCommLeft.push_back(newComm) ;
-              interComm.push_back(newComm) ;
-
-              break;
-            }
-          }
-        }
-
+            int clientLeader;
+            if (nbSndSrvPools < 2)
+//            if (nbSndSrvPools < 1)
+            {
+              for(it=leaders.begin();it!=leaders.end();it++)
+              {
+                if (it->first == hashServer1)
+                {
+                  clientLeader=it->second ;
+                  int intraCommSize, intraCommRank ;
+                  MPI_Comm_size(intraComm, &intraCommSize) ;
+                  MPI_Comm_rank(intraComm, &intraCommRank) ;
+                  info(50)<<"intercommCreate::server "<<rank<<" intraCommSize : "<<intraCommSize
+                           <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< clientLeader<<endl ;
+
+                  MPI_Intercomm_create(intraComm, 0, CXios::globalComm, clientLeader, 0, &newComm) ;
+                  interCommLeft.push_back(newComm) ;
+                  interComm.push_back(newComm) ;
+
+                  break;
+                }
+              }
+            }
+            else
+            {
+//              for(it=leadersServers.begin();it!=leadersServers.end();it++)
+              {
+ //               if (it->first == hashServer1)
+                {
+//                  clientLeader=it->second ;
+                  clientLeader = leadersServers[0];
+                  int intraCommSize, intraCommRank ;
+                  MPI_Comm_size(intraComm, &intraCommSize) ;
+                  MPI_Comm_rank(intraComm, &intraCommRank) ;
+                  info(50)<<"intercommCreate::server "<<rank<<" intraCommSize : "<<intraCommSize
+                           <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< clientLeader<<endl ;
+
+                  MPI_Intercomm_create(intraComm, 0, CXios::globalComm, clientLeader, 0, &newComm) ;
+                  interCommLeft.push_back(newComm) ;
+                  interComm.push_back(newComm) ;
+                }
+              }
+            }
+          } // secondary server
+        } // CXios::serverLevel != 0
+
+        if (nbSndSrvPools > 1) delete [] hashAllServers;
         delete [] hashAll ;
 
@@ -204,6 +330,5 @@
       }
 
-//      int rank;
-      MPI_Comm_rank(intraComm,&rank) ;
+      MPI_Comm_rank(intraComm, &rank) ;
       if (rank==0) isRoot=true;
       else isRoot=false;
@@ -489,5 +614,6 @@
        if (CXios::serverLevel == 1)
        {
-         CClient::registerContext(contextId, intraComm);
+//         CClient::registerContext(contextId, intraComm);
+         CClient::registerContextOnSrvPools(contextId, intraComm);
        }
 
@@ -531,4 +657,5 @@
       int numDigit = 0;
       int size = 0;
+      int mpiRank;
       MPI_Comm_size(CXios::globalComm, &size);
       while (size)
@@ -538,5 +665,9 @@
       }
 
-      fileNameClient << fileName << "_" << std::setfill('0') << std::setw(numDigit) << getRank() << ext;
+      if (nbSndSrvPools < 2)
+        mpiRank = getRank();
+      else
+        mpiRank = rankSndServers;
+      fileNameClient << fileName << "_" << std::setfill('0') << std::setw(numDigit) << mpiRank << ext;
       fb->open(fileNameClient.str().c_str(), std::ios::out);
       if (!fb->is_open())
Index: XIOS/dev/dev_olga/src/server.hpp
===================================================================
--- XIOS/dev/dev_olga/src/server.hpp	(revision 992)
+++ XIOS/dev/dev_olga/src/server.hpp	(revision 1009)
@@ -27,9 +27,12 @@
         // Communicators for the primary group of servers
         static MPI_Comm intraComm;
-        static list<MPI_Comm> interCommLeft;   // interComm between server and its client (client or primary server)
+        static list<MPI_Comm> interCommLeft;   // interComm between server (primary or secondary) and its client (client or primary server)
         static list<MPI_Comm> interCommRight;  // interComm between primary server and secondary server (non-empty only for primary server pool)
         static list<MPI_Comm> interComm;       // interCommLeft + interCommRight
         static std::list<MPI_Comm> contextInterComms;
         static CEventScheduler* eventScheduler;
+
+        static int nbSndSrvPools;   // number of secondary server pools
+        static int poolNb;          // for secondary servers; stores the pool number
 
         struct contextMessage
@@ -65,4 +68,5 @@
       private:
         static int rank;
+        static int rankSndServers;
         static StdOFStream m_infoStream;
         static StdOFStream m_errorStream;
Index: XIOS/dev/dev_olga/src/test/test_regular.f90
===================================================================
--- XIOS/dev/dev_olga/src/test/test_regular.f90	(revision 992)
+++ XIOS/dev/dev_olga/src/test/test_regular.f90	(revision 1009)
@@ -20,6 +20,6 @@
   INTEGER :: size, rank
 
-  INTEGER :: nlon = 100 
-  INTEGER :: nlat = 100
+  INTEGER :: nlon = 5 !100 
+  INTEGER :: nlat = 5 !100
   INTEGER :: ncell 
   INTEGER :: ilat, ilon, ind
@@ -37,4 +37,6 @@
   DOUBLE PRECISION,ALLOCATABLE :: bounds_lat(:,:)
   DOUBLE PRECISION,ALLOCATABLE :: field_temp(:,:)
+  DOUBLE PRECISION,ALLOCATABLE :: field_temp1(:,:)
+  DOUBLE PRECISION,ALLOCATABLE :: field_temp2(:,:)
 
 !!! MPI Initialization
@@ -118,9 +120,14 @@
   ALLOCATE(bounds_lat(4,ni))
   ALLOCATE(field_temp(ni,ntime)) 
-  lon = lon_glo(1+ibegin:1+ibegin+ni)
-  lat = lat_glo(1+ibegin:1+ibegin+ni)
-  bounds_lon(:,:) = bounds_lon_glo(:,1+ibegin:1+ibegin+ni)
-  bounds_lat(:,:) = bounds_lat_glo(:,1+ibegin:1+ibegin+ni)
+  ALLOCATE(field_temp1(ni,ntime))
+  ALLOCATE(field_temp2(ni,ntime))
+  lon = lon_glo(ibegin:1+ibegin+ni)
+  lat = lat_glo(ibegin:1+ibegin+ni)
+  bounds_lon(:,:) = bounds_lon_glo(:,ibegin:1+ibegin+ni)
+  bounds_lat(:,:) = bounds_lat_glo(:,ibegin:1+ibegin+ni)
+
   field_temp(:,:) = rank
+  field_temp1(:,:) = rank
+  field_temp2(:,:) = rank + 10
 
 
@@ -135,8 +142,11 @@
                             time_origin=xios_date(1999, 01, 01, 15, 00, 00))
 
-  CALL xios_set_domain_attr("face", ni_glo=ncell, ibegin=ibegin, ni=ni, type='unstructured')
-  CALL xios_set_domain_attr("face", lonvalue_1d=lon, latvalue_1d=lat)
-  CALL xios_set_domain_attr("face", bounds_lon_1d=bounds_lon, bounds_lat_1d=bounds_lat)
-
+  CALL xios_set_domain_attr("face1", ni_glo=ncell, ibegin=ibegin, ni=ni, type='unstructured')
+  CALL xios_set_domain_attr("face1", lonvalue_1d=lon, latvalue_1d=lat)
+  CALL xios_set_domain_attr("face1", bounds_lon_1d=bounds_lon, bounds_lat_1d=bounds_lat)
+
+  CALL xios_set_domain_attr("face2", ni_glo=ncell, ibegin=ibegin, ni=ni, type='unstructured')
+  CALL xios_set_domain_attr("face2", lonvalue_1d=lon, latvalue_1d=lat)
+  CALL xios_set_domain_attr("face2", bounds_lon_1d=bounds_lon, bounds_lat_1d=bounds_lat)
    
 !!! Definition du timestep
@@ -160,5 +170,6 @@
 
 !!! On donne la valeur du champ atm
-     CALL xios_send_field("temp",field_temp(:,1))
+     CALL xios_send_field("temp1",field_temp1(:,1))
+     CALL xios_send_field("temp2",field_temp2(:,1))
 
     ENDDO
@@ -178,4 +189,5 @@
     DEALLOCATE(bounds_lon, bounds_lat)
     DEALLOCATE(field_temp)
+    DEALLOCATE(field_temp1, field_temp2)
 
 !!! Fin de XIOS
Index: XIOS/dev/dev_olga/src/type/message.cpp
===================================================================
--- XIOS/dev/dev_olga/src/type/message.cpp	(revision 992)
+++ XIOS/dev/dev_olga/src/type/message.cpp	(revision 1009)
@@ -27,5 +27,6 @@
      size_t retSize=0 ;
      
-     for(it=typeList.begin();it!=typeList.end();it++) retSize+=(*it)->size() ;
+     for(it=typeList.begin();it!=typeList.end();it++)
+    	 retSize+=(*it)->size() ;
      return retSize ;
    }
